/*
 * Copyright 1995-1996, Michael A. Cooper
 * This software may be freely distributed provided that the Author is fully
 * credited, and the software is not sold for profit or used in any for-profit
 * product without the express written consent of the Author.
 */
#ifndef lint
static char RCSid[] = 
"$Header: /src/common/cmd/spm/2.x/RCS/nisplus.c,v 1.8 1996/02/08 23:45:57 mcooper Exp $";
#endif	/* lint */

/*
 * Password Management System Facilities for "nisplus"
 */

#include "defs.h"

#undef NIS_DIR				/* This is defined by NIS+ */

#if	defined(HAVE_NISPLUS)
#include <rpcsvc/nis.h>

/*
 * Get the NIS+ domain name.
 */
char *
NISPLUSgetDomain()
{
    return("");
}

/*
 * Check to see if UserName appears in the "nisplus"
 * password facility.
 */
int
NISPLUScheck(UserName, Facility)
    char		       *UserName;
    Facility_t		       *Facility;
    /*ARGSUSED*/
{
    static char			SearchBuff[BUFSIZ];
    char		       *Domain;
    nis_result		       *Result;

    (void) sprintf(SearchBuff, "[name=%s],passwd.org_dir", UserName);
    Result = nis_list(SearchBuff, EXPAND_NAME, NULL, (void *) NULL);
    if (Result && Result->status == NIS_SUCCESS)
	return(0);
    else {
	if (Debug)
	    Error("NIS+ lookup failed for \"%s\": %s.", 
		  UserName, nis_sperrno(Result->status));
	return(-1);
    }
}

/*
 * Do a getpwnam() for a NIS+ UserName.
 */
struct passwd *
NISPLUSgetpwnam(UserName, Facility)
    char		       *UserName;
    Facility_t		       *Facility;
    /*ARGSUSED*/
{
    static char			SearchBuff[BUFSIZ];
    char		       *Domain;
    nis_result		       *Result;
    register struct passwd     *PwdPtr = NULL;
    static char		       *StrPtr = NULL;

    printf("FAC nisplus getpwnam - not implemented yet.\n");

    return(PwdPtr);
}

/*
 * Get name of our NIS master
 */
char *
NISPLUSgetserver()
{
    char		       *Master = NULL;

    printf("FAC nisplus getserver - not implemented yet.\n");

    return(Master);
}

SPMstat_t
NISPLUSchange(UserName)
    char		       *UserName;
{
    /*return("FAC nisplus change - not implemented yet."); */
    return(RS_ERROR);
}

#endif	/* HAVE_NISPLUS */
