.\"
.\" $Header: /src/common/cmd/spm/2.x/RCS/spmtrans.man,v 1.2 1995/07/28 22:54:57 mcooper Exp $
.\" 
.TH spmtrans 8 "21 Febuary 1995"
.ds ]W USC-UCS
.SH NAME
spmtrans \- System for Password Management Transaction Processor
.SH SYNOPSIS
.B spmtrans
[
.B \-debug
]
[
.B \-|+verbose
]
[
.B \-logstdout
]
[
.B \-transdir
.I dirname
]
[
.B \-transfaclist
.I facility1,facility2,...
]
.SH DESCRIPTION
.B spmtrans
is the transaction processing program for the 
System for Password Management (SPM).
The purpose of
.B spmtrans
is to process the transactions created by 
.B spmd(8).
The 
.B spmd(8)
server
creates transactions in password facility specific directories under
.B /var/spm/transactions.
Each transaction is stored as a seperate file in order to 
minimize locking and rollover issues.
.PP
On startup
.B spmtrans
searches for configuration files to read.  The first file found
is used and the rest discarded.  The config list is:
.sp
.nf
.RS
\fB
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf
\fR
.RE
.fi
.sp
(See the
.B spm.conf(5)
manual for the syntax of
.B spm.conf
files.)
After parsing the configuration file
any arguments supplied on the command line are parsed which will override
what was specified in the
.B spm.conf
file.
.PP
The
.B TransFacList
variable 
(from
.B spm.conf
or via the command line
.B -transfaclist
variable)
is used to determine which password facilities should be checked for
transactions that need to be processed.
.PP
For each facility with transaction logging enabled,
a scan is performed of a directory name of the form:
.br
.sp
.RS
.I TransDir/FacilityName
.RE
.sp
.br
For the
.B NIS
facility, the directory name might be:
.br
.sp
.RS
/var/spm/transactions/nis
.RE
.sp
.br
.PP
Every transaction file found in the facility directory being scanned
is locked and then read into memory.
The transactions are organized in memory by username, in newest to oldest 
order.  
Once all transaction files are read, all transactions for each type of possible
change operation 
(
.B PWD,
.B GECOS,
.B SHELL
)
are performed in one database update operation, if possible.
e.g. The
.B /var/yp/src/passwd
file would be written once with all 
.B PWD
(password)
changes,
then it would be written again with all
.B GECOS
changes (if any).
Transaction files are unlocked and deleted after each successful database
update.
.PP
Each transaction file name is of the format:
.br
.sp
.RS
.I format.ID.Revision
.RE
.sp
.br
The
.I format
portion of the name indicates what format the contents of the file are in.
Currently, only the 
.B spmtr1
format is supported.
The
.I ID.Revision
parts form a unique and ascending number.
New transactions have a higher numeric 
.I ID.Revision
value, then older transactions.
This is used to determine the order of newest to oldest transactions.
.PP
The content format of a
.B spmtr1
transaction file is of the format:
.br
.sp
.RS
\fIUserName\fB:\fIType\fB:\fIOldValue\fB:\fINewValue\fR
.RE
.sp
.br
The 
.I UserName
field indicates which username in the password database the
transaction is for.
The
.I Type
field indicates what type of information the transaction applies to.
Currently, the valid names are
.B "pwd, shell, gecos".
The 
.I OldValue
field is used to indicate what the contents of the database was when the
transaction was made.
If this field does not match what is in the database when the transaction
is processed, the transaction is discarded.
The
.I NewValue
field contains the information to place into the database.
.SH OPTIONS
.IP "\fB\-debug\fR"
Enable debugging messages.
.IP "\fB\-logstdout\fR"
Send logging (messages) to stdout.
The default is to log to the 
.B syslog(8)
facility.
.IP "\fB\-transdir \fIdirname\fR"
Use
.I dirname
as the name of the directory to use for transactions.
.IP "\fB\-transfaclist \fIfacility1,facility2,...\fR"
Enable
transaction processing on
.I facility1,facility2,...
.IP \fB\-verbose|+verbose\fR
Disable (\fB\-verbose\fR) or enable (\fB+verbose\fR) verbose messages.
The default is to enable verbose messages.
.SH FILES
.br
/var/spm/transactions	\- Directory of transactions
.br
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf	\- SPM config files
.SH "SEE ALSO"
spm(1),
spm.conf(5),
spmadm(8),
spmtrans(8)
.SH AUTHOR
Michael A. Cooper, 
.br
University Computing Services, 
.br
University of Southern California.
.SH DIAGNOSTICS
.SH BUGS
